]> git.pld-linux.org Git - packages/rpm-build-macros.git/blob - rpm.macros
- add %nagios_nrpe
[packages/rpm-build-macros.git] / rpm.macros
1 # $Revision$, $Date$
2 # PLD Linux rpm macros.
3 # <http://www.pld-linux.org/>
4
5 # can be used by builder script to check for version
6 %rpm_build_macros       %(R="$Revision$"; RR="${R##: }"; echo ${RR%%?})
7
8 %epoch          0
9 %x8664          x86_64 amd64 ia32e
10
11 # kernel compiler
12 %kgcc           %{__cc}
13 %kgcc_package   gcc
14
15 # compiler version
16 %cc_version     %{expand:%%global cc_version %(%{__cc} -dumpversion || echo ERROR)}%cc_version
17 %cxx_version    %{expand:%%global cxx_version %(%{__cxx} -dumpversion || echo ERROR)}%cxx_version
18
19 %__rm           /bin/rm --interactive=never
20
21 # Build system path macros.
22 %__autoconf     autoconf %{?debug:-Wall}
23 %__automake     automake -a -c -f --foreign
24 %__autopoint    autopoint --force
25
26 # add parallel build flags: -jN
27 #
28 # if you want to disable parallel build do:
29 # echo '%_smp_mflags %{nil}' >> ~/.rpmmacros
30 #
31 %__make         /usr/bin/make %{?_smp_mflags}
32 %__scons        /usr/bin/scons %{?_smp_mflags}
33 %__waf          /usr/bin/waf %{?_smp_mflags}
34 %__cmake        /usr/bin/cmake
35
36 %_smp_mflags %(_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN); \\\
37                                 [ "$_NCPUS" -gt 1 ] && echo "-j$(($_NCPUS * 2))")
38
39 %__gettextize { \
40         if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
41                 gettextize --copy --force --no-changelog; \
42         else \
43                 gettextize --copy --force --no-changelog --intl; \
44         fi; \
45         if [ ! -f po/Makevars ]; then \
46                 cp -f po/Makevars{.template,}; \
47         fi; \
48 }
49
50 %__glib_gettextize      glib-gettextize --copy --force
51 %__gnome_doc_common     gnome-doc-common --copy
52 %__gnome_doc_prepare    gnome-doc-prepare --copy --force
53 %__gtkdocize            gtkdocize --copy
54 %__intltoolize          intltoolize --copy --force
55 %__libtoolize           libtoolize --copy --force --install
56
57 # topdir is where builder script lives,
58 # fallback to old style if SPECS/SOURCES dirs were found.
59 %_topdir    %{expand:%%global _topdir %(
60         if [ -d SPECS -a -d SOURCES ]; then
61                 # old style rpmdir: in topdir
62                 pwd
63         elif [ -d ../SPECS -a -d ../SOURCES ]; then
64                 # old style rpmdir: in subdir
65                 cd ..; pwd
66         elif [ -d $HOME/rpm/SPECS -a -d $HOME/rpm/SOURCES ]; then \
67                 # if old style rpm dir exist, go with it
68                 echo $HOME/rpm; \
69         elif [ -x ../builder -a ! -d ../builder ]; then
70                 # relative new style rpmdir: in package dir
71                 cd ..; pwd
72         elif [ -x builder -a ! -d builder ]; then
73                 # relative new style rpmdir: in packages
74                 pwd
75         elif [ -x packages/builder -a ! -d packages/builder ]; then
76                 # relative new style rpmdir: packages dir in current dir
77                 cd packages; pwd
78         else
79                 # fallback to new style rpmdir
80                 echo $HOME/rpm/packages
81         fi; \
82 )}%_topdir
83
84 # if %{_topdir}/SPECS exists, it's old style structure
85 %_specdir       %{expand:%%global _specdir %([ ! -d %{_topdir}/SPECS ] && echo %{_topdir}/%{name} || echo %{_topdir}/SPECS)}%_specdir
86 %_sourcedir             %{expand:%%global _sourcedir %([ ! -d %{_topdir}/SOURCES ] && echo %{_specdir} || echo %{_topdir}/SOURCES)}%_sourcedir
87
88 # BUILD/RPMS/SRPMS are one same level by default as packages dir, if these exist
89 # if they don't exist assume we are having custom topdir (which is not named as
90 # "packages", i.e ~/rpm/kde/{kdelibs,BUILD/RPMS/SRPMS})
91 # NOTE: readlink fails if some parent dir is not readable (/home/services/builder for example can't read /home/services), therfore the extra echo
92 %_builddir              %{expand:%%global _builddir %(if [ -d %{_topdir}/BUILD ]; then echo %{_topdir}/BUILD; else readlink -m %{_topdir}/../BUILD || echo %{_topdir}/../BUILD; fi)}%_builddir
93 %_rpmdir                %{expand:%%global _rpmdir %(if [ -d %{_topdir}/RPMS ]; then echo %{_topdir}/RPMS; else readlink -m %{_topdir}/../RPMS || echo readlink -m %{_topdir}/../RPMS; fi)}%_rpmdir
94 %_srcrpmdir             %{expand:%%global _srcrpmdir %(if [ -d %{_topdir}/SRPMS ]; then echo %{_topdir}/SRPMS; else readlink -m %{_topdir}/../SRPMS || echo readlink -m %{_topdir}/../SRPMS; fi)}%_srcrpmdir
95
96 #       The number of cvs changelog entries kept when building package.
97 %_buildchangelogtruncate 20
98
99 %dependencytracking     %{nil}
100
101 #       Relations between package names that cause dependency loops
102 #       with legacy packages that cannot be fixed. Relations are
103 #       specified as
104 #               p>q
105 #       where package p has a Requires: on something that package q Provides:
106 #
107 # XXX   Note: that there cannot be any whitespace within the string "p>q",
108 #       and that both p and q are package names (i.e. no version/release).
109 %_dependency_whiteout   %{nil}
110
111 #-----------------------------------------------------------------
112 #
113 # (re)definition of %{rpm*flags} with %filterout_* support
114 # BuildRequires:        awk
115 # BuildRequires:        rpmbuild(macros) >= 1.315
116 #
117 # Flags specified in %filterout_* are removed from %rpm*flags, exactly:
118 # %rpmcflags    = %optflags - %filterout - %filterout_c   - %filterout_ld
119 # %rpmcxxflags  = %optflags - %filterout - %filterout_cxx - %filterout_ld
120 # %rpmcppflags  = %optcppflags - %filterout - %filterout_cpp - %filterout_ld
121 # %rpmldflags   = %optldflags - %filterout_ld
122 #
123 # Regular expressions are supported, but to avoid some character be treated
124 # as regular expression it must be escaped twice.
125
126 %filter_out                                             \
127         for (i = 1; i in I; i++) {      A=0;    \
128                 for (f in F) {                          \
129                         if (I[i] ~ "^" F[f] "$") A=1;   \
130                 };                                                      \
131                 if (!A) printf(I[i] FS);        \
132         }
133
134 %rpmcflags %(awk 'BEGIN {
135         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
136         split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
137         %{filter_out}
138 }')
139
140 %rpmcxxflags %(awk 'BEGIN {
141         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
142         split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
143         %{filter_out}
144 }')
145
146 %rpmcppflags %(awk 'BEGIN {
147         split("%{?debug:%debugcppflags}%{!?debug:%optcppflags}%{?debuginfocppflags}",I);
148         split("%{?filterout} %{?filterout_cpp} %{?filterout_cpp}",F);
149         %{filter_out}
150 }')
151
152 %rpmldflags %(awk 'BEGIN {
153         split("%{?optldflags}",I);
154         split("%{?filterout_ld}",F)
155         %{filter_out}
156 }')
157
158 # rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
159 # but, don't use it, better use gcc as linker
160 %ld_rpmldflags %(awk 'BEGIN {
161         split("%{rpmldflags}",F);
162         for (f in F) {
163                 s = F[f];
164                 if (s ~ /^-Wl,/) {
165                         s = substr(s,5);
166                         gsub(/,/," ",s);
167                 };
168                 printf(s FS);
169         };
170 }')
171
172 #-----------------------------------------------------------------
173 #
174 #  Generate a command which cleans environment, leaving only the
175 # most important variables.
176 #  If any spec requires any additional environment it should
177 # redefine %_preserve_env in following manner:
178 #
179 #       # ADDITIONAL_VAR is required because [a good reason here]
180 #       %define _preserve_env ADDITIONAL_VAR
181
182 %_preserve_env_base     PATH HOME TMP TMPDIR SSH_AUTH_SOCK
183
184 # "env -i" must end in first line of expaned macros because it's used as first line of shell script (#! env...)
185 %_clean_env             %{!?_preserve_env:%global _preserve_env %{nil}}%{expand:%%global _preserve_env %{_preserve_env} %_preserve_env_base} env -i %(awk -vq="'" -vqq="\\"'\\"" -vq2q="'\\"'" 'BEGIN {
186         split("%{?_preserve_env}", P);
187         for (i in P) {
188                 p = P[i];
189                 if (!ENVIRON[p] || d[p]) {
190                         continue;
191                 }
192                 d[p] = 1;
193                 split(ENVIRON[p], V, "");
194                 val = p "=";
195                 for (j = 1; j in V; j++) {
196                         v = V[j];
197                         if (v == q)
198                                 v = qq;
199                         else if (v == "\\"")
200                                 v = q2q;
201                         else if (v == "\\\\")
202                                 v = "\\\\\\\\";
203                         else
204                                 gsub("[^a-zA-Z0-9/:._-]", "\\"&\\"", v);
205                         val = val "" v;
206                 }
207                 printf(val " ");
208         }
209 }')
210
211 #-----------------------------------------------------------------
212 %configure2_13 { \
213  if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
214  LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
215  CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
216  CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
217  FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
218  FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
219  CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" ; export CPPFLAGS ; \
220  %{?__cc:CC="%{__cc}" ; export CC ; } \
221  %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
222  %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
223         --host=%{_target_platform} \
224         --prefix=%{_prefix} \
225         --exec-prefix=%{_exec_prefix} \
226         --bindir=%{_bindir} \
227         --sbindir=%{_sbindir} \
228         --sysconfdir=%{_sysconfdir} \
229         --datadir=%{_datadir} \
230         --includedir=%{_includedir} \
231         --libdir=%{_libdir} \
232         --libexecdir=%{_libexecdir} \
233         --localstatedir=%{_localstatedir} \
234         --sharedstatedir=%{_sharedstatedir} \
235         --mandir=%{_mandir} \
236         --infodir=%{_infodir} \
237         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
238         %{dependencytracking} \
239 }
240
241 %cmake { \
242 CC="%{__cc}" \
243 CXX="%{__cxx}" \
244 CFLAGS="%{rpmcflags}" \
245 CXXFLAGS="%{rpmcxxflags}" \
246 LDFLAGS="%{rpmldflags}" \
247 %{__cmake} \
248 }
249
250 %scons { \
251 %{__scons} \
252         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
253         CFLAGS="${CFLAGS:-%rpmcflags}" \
254         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
255         FFLAGS="${FFLAGS:-%rpmcflags}" \
256         CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
257         %{?__cc:CC="%{__cc}"} \
258         %{?__cxx:CXX="%{__cxx}"} \
259         libsuffix=%{_lib} \
260         prefix=%{_prefix} \
261 }
262
263 # waf. see waf.spec
264 %waf { \
265 CC="%{__cc}" \
266 CXX="%{__cxx}" \
267 CPP="%{__cpp}" \
268 CFLAGS="%{rpmcflags}" \
269 CXXFLAGS="%{rpmcxxflags}" \
270 %{__waf} \
271 }
272
273 #----------------------------------------------------------------
274 #%configure_cache 0
275 %configure_cache_file   %{buildroot}.configure.cache
276
277 %configure {./configure \
278         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
279         CFLAGS="${CFLAGS:-%rpmcflags}" \
280         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
281         FFLAGS="${FFLAGS:-%rpmcflags}" \
282         FCFLAGS="${FCFLAGS:-%rpmcflags}" \
283         CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
284         %{?__cc:CC="%{__cc}"} \
285         %{?__cxx:CXX="%{__cxx}"} \
286         --host=%{_target_platform} \
287         --build=%{_target_platform} \
288         --prefix=%{_prefix} \
289         --exec-prefix=%{_exec_prefix} \
290         --bindir=%{_bindir} \
291         --sbindir=%{_sbindir} \
292         --sysconfdir=%{_sysconfdir} \
293         --datadir=%{_datadir} \
294         --includedir=%{_includedir} \
295         --libdir=%{_libdir} \
296         --libexecdir=%{_libexecdir} \
297         --localstatedir=%{_localstatedir} \
298         --sharedstatedir=%{_sharedstatedir} \
299         --mandir=%{_mandir} \
300         --infodir=%{_infodir} \
301         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
302         %{dependencytracking} \
303         %{?configure_cache:--cache-file=%{configure_cache_file}} \
304 }
305
306 # Simple macros to simplify adding bconded options to configure scripts.
307 #   Each macro requires bcond name and accepts optional option name, if option
308 # isn't specified bcond name is used as option name. Options returning
309 # --with and --enable also allow third argument which will be added as value
310 # ( --with-option=value or --enable-option=value ) in case or positive
311 # condition, but won't be added otherwise ( nothing or just --disable-option ).
312
313 # Requirements:
314 # BuildRequires: rpmbuild(macros) >= 1.527
315
316 # Usage example:
317 # %{__enable bcond} - returns --enable-bcond iff build condition is set
318 # %{__disable bcond option} - returns --enable-option iff bcond is not set
319 # %{__enable_disable bcond option value} - returns --enable-option=value if
320 #    bcond is set, returns --disable-option otherwise
321
322 # expand bconds to --enable-something and --disable-something
323 %__enable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
324 %__disable() %{expand:%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
325 %__enable_disable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
326
327 # same as above, but condition inverted
328 %__enable_unless() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
329 %__disable_if() %{expand:%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
330 %__enable_disable_not() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
331
332 # expand bconds to --with-something and --without-something
333 %__with() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
334 %__without() %{expand:%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
335 %__with_without() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
336
337 # same as above, but condition inverted
338 %__with_unless() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
339 %__without_if() %{expand:%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
340 %__with_without_not() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
341
342 #-----------------------------------------------------------------
343
344 # overload to insert debuginfo package
345 %prep \
346 %if 0%{?_enable_debug_packages}\
347 %{debug_package}\
348 %endif\
349 %%prep\
350 %{nil}
351
352 # Location of autoconf macros
353 %_aclocaldir    %{expand:%%global _aclocaldir %(aclocal --print-ac-dir || echo ERROR)}%_aclocaldir
354
355 # Location of omf files
356 %_omf_dest_dir  %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
357
358 # Location of pkgconfig files
359 %_pkgconfigdir  /usr/%{_lib}/pkgconfig
360 # noarch pkgconfig files
361 %_npkgconfigdir /usr/share/pkgconfig
362
363 # Location of desktop files
364 %_desktopdir    /usr/share/applications
365 %_applnkdir     ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
366
367 # Location of pixmaps for applnk/desktop files
368 %_pixmapsdir    /usr/share/pixmaps
369
370 # Location of themable icons for applnk/desktop files
371 %_iconsdir      /usr/share/icons
372
373 # Location of fonts directories
374 %_fontsdir      /usr/share/fonts
375
376 # Location of Gtk and associated libraries documentation
377 %_gtkdocdir     %{_defaultdocdir}/gtk-doc/html
378
379 # Location of KDE documentation
380 %_kdedocdir     %{_defaultdocdir}/kde/HTML
381
382 # unsermake script
383 %__unsermake /usr/share/unsermake/unsermake
384
385 # Current date
386 %date           %(LC_ALL=C date +"%a %b %d %Y")
387
388 # Example files, programs, scripts...
389 %_examplesdir   /usr/src/examples
390
391 # Alternative kernel type/version
392 %_alt_kernel    %{nil}%{?alt_kernel:-%{?alt_kernel}}
393
394 # The directory holding Linux kernel sources
395 %_kernelsrcdir  /usr/src/linux%{_alt_kernel}
396
397 # SysV-style initscripts dir
398 %_initddir              /etc/rc.d/init.d
399
400 # If non-empty "debug" macro defined, add "dbg" suffix to release number
401 %_rpmfilename           %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
402
403 # -n drm to generate kernel%{_alt_kernel}-drm dependency
404 %releq_kernel(n:)               %{expand:%%global releq_kernel %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
405 %releq_kernel_up(n:)    %{expand:%%global releq_kernel_up %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
406 %releq_kernel_smp(n:)   %{expand:%%global releq_kernel_smp %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
407
408 # -s post to generate Requires(post) dependency
409 %requires_releq_kernel(s:n:)            Requires%{-s:(%{-s*})}: %releq_kernel
410 %requires_releq_kernel_up(s:n:)         Requires%{-s:(%{-s*})}: %releq_kernel_up
411 %requires_releq_kernel_smp(s:n:)        Requires%{-s:(%{-s*})}: %releq_kernel_smp
412
413 # Requires name = version-release
414 %requires_releq()       %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to -r %1 %1}}}
415 # Requires: name = version
416 %requires_eq()          %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to %1 %1}}}
417 # Requires: name = version (version based on querying package %2)
418 %requires_eq_to(r)      %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
419
420 %apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
421
422 # kernel version-release handling
423 %__kernel_ver    %{expand:%%global __kernel_ver %( \\
424         Z=$([ -f '%{_kernelsrcdir}/include/generated/utsrelease.h' ] && awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/{linux/version,generated/utsrelease}.h 2>/dev/null || awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/linux/{version,utsrelease}.h 2>/dev/null); \\
425         Z=${Z:-$(awk -F' = ' '/^VERSION/{v=$2} /^PATCHLEVEL/{p=$2} /^SUBLEVEL/{s=$2} /^EXTRAVERSION/{e=$2} END {printf("%d.%d.%d%s", v, p, s, e)}' %{_kernelsrcdir}/Makefile 2>/dev/null)}; \\
426         echo ${Z:-ERROR}; \\
427 )}%__kernel_ver
428
429 %__kernel_rel   %{expand:%%global __kernel_rel %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
430 %__kernel_rpmvr %{expand:%%global __kernel_rpmvr %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
431 %_kernel_ver    %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
432 %_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
433
434 # `uname -r` to be used in @release field
435 %_kernel_vermagic       %{expand:%%global _kernel_vermagic %(echo %{_kernel_ver} | sed -e 's/-/_/g')}%_kernel_vermagic
436
437 # sgml macros
438 %xmlcat_add()           /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
439 %xmlcat_del()           /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
440 %xmlcat_add_rewrite     /usr/bin/xmlcatalog --noout --add rewriteSystem
441 %xmlcat_create()        /usr/bin/xmlcatalog --noout --create %1 ;
442 %sgmlcat_add()          /usr/bin/install-catalog --add %1 %2 > /dev/null ;
443 %sgmlcat_del()          /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
444 %docbook_sgmlcat_fix() { for l in \
445 '' \
446 '  -- default decl --' \
447 'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
448 '  -- hacks for opensp --' \
449 'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
450 'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd"                  "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
451 '' \
452 ; do echo $l; done >> %1 \
453 }
454
455 # vim - "
456
457 # minimum file size needed for compressed documents.
458 # just smaller files than this get larger when compressed.
459 # some stats:
460 # - 0 byte file compressed was 25 bytes .gz
461 # - 39 byte file was compressed as 57
462 # - with test/test.spec@man 158 byte file was compressed also 158
463 %_min_compress_bytes    159
464
465 #-----------------------------------------------------------------
466 # find and gzip all files in %{_mandir} and %{infodir}
467 #
468 # Requires: xargs, find
469 #
470 #%no_install_post_compress_docs 1
471 %__spec_install_post_compress_docs { \
472 %{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
473         for i in /usr/share/man /usr/X11R6/man; do \
474                 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
475                         echo "Compress man pages: $i"; \
476                         find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
477                         find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
478                         find $RPM_BUILD_ROOT$i -type l | while read a; do \
479                                 m=$(readlink $a); \
480                                 rm -f $a; \
481                                 echo .so ${m##*/} > $a; \
482                                 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
483                         done; \
484                         find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
485                 fi; \
486         done; \
487         if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
488                 echo "Compress info pages: %{_infodir}"; \
489                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
490                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
491                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
492         fi; \
493 }; __spec_install_post_compress_docs } }
494
495 #-----------------------------------------------------------------
496 # Strip executable binaries and shared object files
497 #
498 # Requires: find, awk, strip, cut, xargs
499 #
500 # Special macros which affect this process:
501 #%no_install_post_strip 1               # disable stripping at all
502 #%_noautostrip                  regexp  # exclude files matching (anchored!) regex from stripping
503 #%_autostripall                 regexp  # strip files matching (anchored!) regex using plain strip
504 #%_autostripunneeded    regexp  # strip files matching (anchored!) regex using strip --strip-unneeded
505 #%_autostripdebug               regexp  # strip files matching (anchored!) regex using strip --strip-debug
506 #
507 %__spec_install_post_strip {%{!?debug: \
508 %{!?no_install_post_strip:__spec_install_post_strip() { \
509 if [ -d "$RPM_BUILD_ROOT" ]; then \
510         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
511                 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
512                 if [ "$modulelist" ]; then \
513                         modulecount=$(echo "$modulelist" | wc -l); \
514                         printf "Stripping %d kernel modules..." $modulecount; \
515                         echo "$modulelist" | xargs -l512 chmod u+w; \
516                         echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
517                         echo "DONE"; \
518                 fi; \
519         fi; \
520         filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
521         if [ -n "$filelist" ]; then \
522                 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
523                 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
524                 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
525                 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
526                 if [ -n "$elfexelist" ]; then \
527                         printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
528                         chmod u+w $elfexelist; \
529                         %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
530                         echo "DONE"; \
531                 fi; \
532                 if [ -n "$elfsharedlist" ]; then \
533                         printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
534                         chmod u+w $elfsharedlist; \
535                         %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
536                         echo "DONE"; \
537                 fi; \
538                 if [ -n "$archiveslist" ]; then \
539                         printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
540                         chmod u+w $archiveslist; \
541                         %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
542                         echo "DONE"; \
543                 fi; \
544         fi; \
545     filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
546     filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
547     filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
548         if [ -n "$filelist_all" ]; then \
549                 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
550                 chmod u+w $filelist_all; \
551                 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
552                 echo "DONE"; \
553         fi; \
554         if [ -n "$filelist_unneeded" ]; then \
555                 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
556                 chmod u+w $filelist_unneeded; \
557                 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
558                 echo "DONE"; \
559         fi; \
560         if [ -n "$filelist_debug" ]; then \
561                 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
562                 chmod u+w $filelist_debug; \
563                 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
564                 echo "DONE"; \
565         fi; \
566 fi; }; __spec_install_post_strip } } }
567
568 #-----------------------------------------------------------------
569 # remove all RPATH from executable binaries and shared object files
570 #
571 # Requires: find, awk, cut, xargs, chrpath, uname
572 #
573 # Special macros which affect this process
574 #%no_install_post_chrpath       1       # disable chrpath at all
575 #%_noautochrpath        regex           # exclude files matching (anchored!) regex from chrpath
576 #
577 %__spec_install_post_chrpath {%{!?debug: \
578 %{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
579 if [ -d "$RPM_BUILD_ROOT" ]; then \
580         files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
581         if [ -n "$files" ]; then \
582                 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
583         fi; \
584         if [ -n "$objs" ]; then \
585                 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
586                 echo "$objs" | \
587                 while read file; do \
588                         rpath= ; \
589                         chmod u+w "$file"; \
590                         for dir in $(chrpath -l "$file" | awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'); do \
591                                         case $dir in \
592                                         '$ORIGIN' ) \
593                                                 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
594                                                 else rpath="$rpath:$dir" ; fi ; \
595                                                 continue ; \
596                                                 ;; \
597                                         esac ; \
598                                         newdir=$(readlink -m "$dir"); \
599                                         [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
600                                         case $dir in \
601                                         /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
602                                                 echo "remove-rpath: $dir in $file"; \
603                                                 ;; \
604                                         * ) \
605                                                 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
606                                                 else rpath="$rpath:$dir" ; fi ; \
607                                                 ;; \
608                                         esac ; \
609                         done ; \
610                         if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
611                         else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
612                 done; \
613         fi; \
614 fi; }; __spec_install_post_chrpath } } }
615
616 # vim: "
617
618 #-----------------------------------------------------------------
619 # Find all shared object files with unresolved symbols. Warn
620 # and terminate if any found (termination can be turned off by define).
621 #%no_install_post_check_so 1
622 %__spec_install_post_check_so { \
623  __spec_install_post_check_so() { \
624     fail=0; \
625     printf "Searching for shared objects with unresolved symbols..."; \
626     for f in $(find $RPM_BUILD_ROOT -type f -name '*.so.*' -print); do \
627         LC_ALL=C objdump -T $f 2> /dev/null | LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; skip["program_name"]=1; symbols = "" } /^[0-9a-z]+ +D +\*UND\*/ { if ($NF in skip) { next; }; found = 1; symbols = symbols "\n\t" $NF } END { if (found) { print "\nUnresolved symbols found in: " file symbols; exit(1); } } ' || fail=1 ; \
628     done ; \
629     echo " DONE"; \
630     %{!?no_install_post_check_so:[ $fail -eq 1 ] && : || :;} \
631 }; __spec_install_post_check_so }}
632
633 #-----------------------------------------------------------------
634 # Find and gzip all kernel modules
635 #
636 # Requires: find
637 #
638 #%no_install_post_compress_modules      1
639 %__spec_install_post_compress_modules { \
640 %{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
641         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
642                 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
643                 if [ "$q" ]; then \
644                         printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
645                         echo "$q" | xargs -r %{__gzip} -9nf; \
646                         echo "DONE"; \
647                         find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
648                         while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
649                 fi; \
650         fi; \
651 }; __spec_install_post_compress_modules } }
652
653 # Remove common Perl files we don't package
654 %__spec_install_post_perl_clean {\
655 %{!?no_install_post_perl_clean: \
656 %{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
657 } }
658
659 #-----------------------------------------------------------------
660 # Update GConf2 schemas
661 #
662 # Requires: GConf2
663 #
664 %gconf_schema_install() \
665         umask 022; \
666         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
667         /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
668 %{nil}
669
670 %gconf_schema_uninstall() \
671 if [ $1 = 0 -a -x /usr/bin/gconftool-2 ]; then \
672         umask 022; \
673         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
674         /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
675 fi; \
676 %{nil}
677
678 #-----------------------------------------------------------------
679 # Update desktop MIME database
680 # requires: desktop-file-utils
681 %update_desktop_database() {{ \
682         umask 022; \
683         /usr/bin/update-desktop-database -q; \
684 };} \
685 %{nil}
686
687 %update_desktop_database_post %update_desktop_database
688
689 %update_desktop_database_postun() {{ \
690 if [ "$1" = "0" ]; then \
691         %update_desktop_database \
692 fi; \
693 };} \
694 %{nil}
695
696 #-----------------------------------------------------------------
697 # Update shared MIME info database
698 # requires: shared-mime-info
699 #
700 %update_mime_database() {{ \
701         umask 022; \
702         /usr/bin/update-mime-database %{_datadir}/mime; \
703 };} \
704 %{nil}
705
706 #-----------------------------------------------------------------
707 # Update icon cache
708 # requires: gtk+
709 #
710 %update_icon_cache() {{ \
711         umask 022; \
712         /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
713 };} \
714 %{nil}
715
716 #-----------------------------------------------------------------
717 # Update scrollkeeper database
718 # requires: scrollkeeper
719 #
720 %scrollkeeper_update_post() \
721         /usr/bin/scrollkeeper-update -q; \
722 %{nil}
723
724 %scrollkeeper_update_postun() \
725 if [ "$1" = "0" ]; then \
726         /usr/bin/scrollkeeper-update -q; \
727 fi; \
728 %{nil}
729
730 #-----------------------------------------------------------------
731 # post %install sequence:
732 # - autodeps exceptions
733 # - compress all man and info pages,
734 # - strip all ELF executables and ELF shared objects if not %debug.
735 # - compress kernel modules if any
736
737 ###################################################################
738 # Requires/Provides automation
739 # exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
740 #
741 %__noautoreqfiles       %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
742 %__noautoprovfiles      %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
743 %__noautoreq            %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
744 %__noautoreqdep         %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
745 %__noautoprov           %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
746
747 #%_noautocompressdoc    %{nil}
748 #
749 %_missing_doc_files_terminate_build     1%{nil}
750 %_unpackaged_files_terminate_build      %{nil}
751 # (X)emacs support
752 %___emacs_lispdir_helper  -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
753 %_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
754 %_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
755
756 %__php_provides %{nil}
757 %__php_requires %{nil}
758 %__perl_provides %{nil}
759 %__perl_requires %{nil}
760 %__mono_provides %{nil}
761 %__mono_requires %{nil}
762
763 # Perl specific macro definitions.
764 %perl_privlib           %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
765 %perl_archlib           %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
766 %perl_vendorlib         %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
767 %perl_vendorarch        %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
768 %perl_sitelib           %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
769 %perl_sitearch          %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
770
771 # Ruby
772 %__ruby                         /usr/bin/ruby
773 %ruby_archdir           %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
774 %ruby_ridir                     %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
775 %ruby_rubylibdir        %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
776 %ruby_vendorarchdir     %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
777 %ruby_vendorlibdir      %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
778 %ruby_sitearchdir       %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
779 %ruby_sitelibdir        %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
780 %ruby_rdocdir           /usr/share/rdoc
781 %ruby_version           %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
782 %ruby_ver_requires_eq   Requires:       ruby(ver) = %ruby_version
783 %ruby_mod_ver_requires_eq       Requires:       ruby-modules(ver) = %ruby_version
784
785 %php_pear_dir           /usr/share/pear
786 %php_data_dir           /usr/share/php
787 %php_extensiondir       %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
788 %php_sysconfdir         %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
789 %php_includedir         %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
790
791 # extract php/zend api versions
792 %php_major_version              %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
793 %php_minor_version              %{expand:%%global php_minor_version %(awk '/#define PHP_MINOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_minor_version
794 %php_api_version                %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
795 %php_pdo_api_version    %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
796 %php_debug                              %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
797 %zend_module_api                %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
798 %zend_extension_api             %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
799 %zend_zts                               %{expand:%%global zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%zend_zts
800
801 # helper macro
802 %__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
803
804 # macros for public use
805 # for php extensions (php-pecl)
806 %requires_php_extension %{__php_api_requires modules_api php_api_version} \
807 %{__php_api_requires zend_module_api} \
808 %{__php_api_requires -v %php_major_version debug php_debug} \
809 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
810
811 # for zend extensions
812 %requires_zend_extension %{__php_api_requires zend_module_api} \
813 %{__php_api_requires zend_extension_api} \
814 %{__php_api_requires -v %php_major_version debug php_debug} \
815 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
816
817 # for php pdo modules (php-pecl-PDO_*)
818 %requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
819
820 # for using PHP post scripts. for PHP >= 5.0
821 %php_webserver_restart \
822 [ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
823 [ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
824 if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
825         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
826         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
827                 %service -q php-fcgi restart \
828         fi \
829 fi \
830 if [ -x /etc/rc.d/init.d/php-fpm ]; then \
831         %service -q php-fpm restart \
832 fi \
833 %{nil}
834
835 # for using php post scripts. for PHP >= 4.0 && PHP < 5.0
836 %php4_webserver_restart \
837 [ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
838 [ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
839 if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
840         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
841         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
842                 %service -q php-fcgi restart \
843         fi \
844 fi \
845 %{nil}
846
847 # X.org helper macros
848 %__xorg_abi_requires_ge() Requires: xorg-xserver-server(%{expand:%1}-abi) >= %{expand:%{%2}}
849 %__xorg_abi_requires_lt() Requires: xorg-xserver-server(%{expand:%1}-abi) < %(awk -vv=%{expand:%{%2}} 'BEGIN{split(v, a, "."); printf("%s.0", a[1] + 1); exit}')
850
851 %xorg_xserver_ansic_abi         %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
852 %xorg_xserver_extension_abi     %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
853 %xorg_xserver_font_abi          %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
854 %xorg_xserver_videodrv_abi      %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
855 %xorg_xserver_xinput_abi        %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
856 # vim: '
857
858 %requires_xorg_xserver_extension \
859 %{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
860 %{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
861 %{__xorg_abi_requires_ge extension xorg_xserver_extension_abi} \
862 %{__xorg_abi_requires_lt extension xorg_xserver_extension_abi} \
863 %{nil}
864
865 %requires_xorg_xserver_xinput \
866 %{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
867 %{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
868 %{__xorg_abi_requires_ge xinput xorg_xserver_xinput_abi} \
869 %{__xorg_abi_requires_lt xinput xorg_xserver_xinput_abi} \
870 %{nil}
871
872 %requires_xorg_xserver_font \
873 %{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
874 %{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
875 %{__xorg_abi_requires_ge font xorg_xserver_font_abi} \
876 %{__xorg_abi_requires_lt font xorg_xserver_font_abi} \
877 %{nil}
878
879 %requires_xorg_xserver_videodrv \
880 %{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
881 %{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
882 %{__xorg_abi_requires_ge videodrv xorg_xserver_videodrv_abi} \
883 %{__xorg_abi_requires_lt videodrv xorg_xserver_videodrv_abi} \
884 %{nil}
885
886 # TCL specific macro definitions.
887 # TODO: when th tcl is fixed use tclsh to get version: %(echo 'puts $tcl_version' | tclsh)
888 %tcl_version    %{expand:%%global tcl_version %(v=$(rpm -q --qf %{V} tcl | cut -d. -f1,2); echo ${v:-ERROR})}%tcl_version
889 %tcl_sitearch   %{_libdir}/tcl%{tcl_version}
890 %tcl_sitelib    %{_datadir}/tcl%{tcl_version}
891
892 # Python specific macro definitions.
893 # python main version
894 %py_ver                 %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" 2>/dev/null || echo ERROR)}%py_ver
895
896 # directories
897 %py_prefix              %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" 2>/dev/null || echo ERROR)}%py_prefix
898 %py_libdir              %{py_prefix}/%{_lib}/python%{py_ver}
899 %py_scriptdir   %{py_prefix}/share/python%{py_ver}
900 %py_incdir              /usr/include/python%{py_ver}
901 %py_sitedir             %{py_libdir}/site-packages
902 %py_sitescriptdir %{py_scriptdir}/site-packages
903 %py_dyndir              %{py_libdir}/lib-dynload
904
905 # pure python modules compilation
906 %py_comp                python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
907
908 %py_ocomp               python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
909
910 # Software written in Python language require Python with main version
911 %pyrequires_eq() Requires:      %1
912
913 # Python 3.x
914 # python main version
915 %__python3                      python3
916 %py3_ver                        %{expand:%%global py3_ver %(%{__python3} -c "import sys; print(sys.version[:3])" 2>/dev/null || echo ERROR)}%py3_ver
917
918 # directories
919 %py3_prefix             %{expand:%%global py3_prefix %(%{__python3} -c "import sys; print(sys.prefix)" 2>/dev/null || echo ERROR)}%py3_prefix
920 %py3_libdir             %{py3_prefix}/%{_lib}/python%{py3_ver}
921 %py3_scriptdir  %{py3_prefix}/share/python%{py3_ver}
922 %py3_incdir             /usr/include/python%{py3_ver}
923 %py3_sitedir            %{py3_libdir}/site-packages
924 %py3_sitescriptdir %{py3_scriptdir}/site-packages
925 %py3_dyndir             %{py3_libdir}/lib-dynload
926
927 # pure python modules compilation
928 %py3_comp               %{__python3} -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
929
930 %py3_ocomp              %{__python3} -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
931
932 # Hardlink binary identical .pyc and .pyo files
933 %__spec_install_post_py_hardlink {\
934 %{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
935 local a b c=0 t=0; \
936 if [ -d "$RPM_BUILD_ROOT" ]; then \
937         find "$RPM_BUILD_ROOT" -name '*.pyc' > __rpm_pyc; \
938         while read a; do \
939                 b="${a%.pyc}.pyo"; \
940                 if cmp -s "$a" "$b"; then \
941                         ln -f "$a" "$b"; \
942                         c=$((c + 1)); \
943                 fi; \
944                 t=$((t + 1)); \
945         done < __rpm_pyc; \
946         [ $t -gt 0 ] && printf "Hardlink Python files: %d/%d files hardlinked\n" $c $t; \
947         rm -f __rpm_pyc; \
948 fi; \
949 }; __spec_install_post_py_hardlink } }
950
951 # remove python sources, so that check-files won't complain
952 %py_postclean() \
953 for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
954  [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
955 done \
956 %{nil}
957
958 %py3_postclean() \
959 for d in %{py3_sitescriptdir} %{py3_sitedir} %*; do \
960  [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
961 done \
962 %{nil}
963
964 # depmod macro
965 %depmod() { \
966 umask 022; \
967 if [ -e /boot/System.map-%1 ]; then \
968         /sbin/depmod -a -F /boot/System.map-%1 %1; \
969 else \
970         if [ -e /boot/System.map ]; then \
971                 /sbin/depmod -a -F /boot/System.map %1; \
972         else \
973                 /sbin/depmod -a %1; \
974         fi \
975 fi; \
976 }
977
978 # XMMS specific macros
979 %xmms_prefix                    %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
980 %xmms_exec_prefix               %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
981 %xmms_version                   %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
982 %xmms_datadir                   %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
983 %xmms_plugindir                 %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
984 %xmms_visualization_plugindir   %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
985 %xmms_input_plugindir           %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
986 %xmms_output_plugindir          %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
987 %xmms_effect_plugindir          %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
988 %xmms_general_plugindir         %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
989
990 %_target_base_arch      %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/;s/sparcv./sparc/')}%_target_base_arch
991
992 # user/group checking macros
993 #
994 # Usage:
995 #       %userremove myuser
996 #
997 %userremove     /usr/lib/rpm/user_group.sh user del
998 %groupremove    /usr/lib/rpm/user_group.sh group del
999 #
1000 # Usage:
1001 #       if %usertestrm myuser; then
1002 #               /usr/sbin/userdel -r myuser
1003 # Note:
1004 #       use these macros only if you need to call userdel/groupdel with
1005 #       a non-standard option or take an extra action; otherwise use the
1006 #       %userremove/%groupremove macros
1007 #
1008 %usertestrm     /usr/lib/rpm/user_group.sh user testrm
1009 %grouptestrm    /usr/lib/rpm/user_group.sh group testrm
1010 # user group membership management macros
1011 #
1012 # Usage:
1013 #       %addusertogroup [-q] myuser agroup
1014 #
1015 #  -q if user or group don't exist, don't make big noise of it (MISSINGOK behaviour)
1016 #
1017 # Requirements:
1018 # BuildRequires:        rpmbuild(macros) >= 1.515
1019 %addusertogroup(q)      quiet=%{-q:1} /usr/lib/rpm/user_group.sh user addtogroup %*; \
1020 %{nil}
1021
1022 # banner support (useful in {pre,post}{,un} and triggers)
1023 #
1024 # Usage:
1025 #       %banner name [-a] [-e] [-n] [-tn] <<EOF
1026 # the banner text, the banner text
1027 # the banner text, and following line
1028 #EOF
1029 # You can use any form of here-document, <<'EOF' <<-EOT will do.
1030 # NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
1031 #
1032 # -a   - append to the banner
1033 # -e   - send to stderr instead of stdout
1034 # -n   - no show banner (overrides -t)
1035 # -t   - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
1036 #
1037 # Tests:
1038 # (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
1039 # rpm -E 'date | %banner -e banner' > m; sh -x m
1040 #
1041 %banner(aent:) ( \
1042 RPM_SCRIPTVERBOSITY=5 \
1043 [ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
1044 if [ -x /usr/bin/banner.sh ]; then \
1045         CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
1046 else \
1047         CMD="cat%{-e: >&2}" \
1048 fi \
1049 eval $CMD %{?2:%2}%{?3: %3}) \
1050 %{nil}
1051
1052 # useradd/groupadd macros
1053 # Author: Elan Ruusamäe <glen@pld-linux.org>
1054 #
1055 # Usage:
1056 #   %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
1057 #   [-g initial_group] [-G group[,...]] login
1058 #
1059 #  -u uid. REQUIRED
1060 #  -g gid/group. REQUIRED
1061 #  -s defaults to /bin/false
1062 #  -d defaults to /usr/share/empty
1063 #  -c No default
1064 #  -r is accepted but ignored (it's always set)
1065 #  -k skeleton dir. defaults to /usr/share/empty
1066 # rpm specific flags
1067 #  -P package name. defaults to %{name}
1068 #
1069 %useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
1070 %{!-u:%{error:useradd: Required argument -u missing}} \
1071 %{!-g:%{error:useradd: Required argument -g missing}} \
1072 %{!?1:%{error:useradd: Required parameter login missing}} \
1073 if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
1074         if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
1075                 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1076                 exit 1 \
1077         fi \
1078 else \
1079         echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
1080         /usr/sbin/useradd \\\
1081                 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
1082                 -u %{-u*} \\\
1083                 -r \\\
1084                 -d %{-d*}%{!-d:/usr/share/empty} \\\
1085                 -s %{-s*}%{!-s:/bin/false} \\\
1086                 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
1087                 -g %{-g*} \\\
1088                 %{-M} \\\
1089                 %{-G:-G %{-G*}} \\\
1090                 %{expand:%{%{#}}} 1>&2 || exit $? \
1091         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
1092 fi;
1093 # vim: "
1094
1095 # Usage:
1096 #   %groupadd [-P package] [-g gid] group
1097 #
1098 # -g gid. REQUIRED
1099 #
1100 # Sample:
1101 #   %groupadd -P %{name}-base -g %{gid} %{name}
1102
1103 %groupadd(g:P:rfo)      \
1104 %{!-g:%{error:groupadd: Required argument -g missing}} \
1105 %{!?1:%{error:groupadd: Required parameter group missing}} \
1106 if /usr/bin/getgid %{1} > /dev/null 2>&1; then \
1107         if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
1108                 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1109                 exit 1 \
1110         fi \
1111 else \
1112         echo "Adding group %{1} GID=%{-g*}." \
1113         /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
1114         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
1115 fi;
1116
1117 # webapp macros
1118 # Author: Elan Ruusamäe <glen@pld-linux.org>
1119 #
1120 # The config is installed/removed inside trigger, this means that you can any
1121 # time install apache1/apache/lighttpd package and the configuration file is
1122 # updated. if you don't need the config for various reason for specific
1123 # webserver, just remove the symlink from config directory using webapp
1124 # program. the trigger will not recreate the symlink on upgrades. In other
1125 # words the config is linked to webserver config directory on first install of
1126 # PACKAGE or WEBSERVER.
1127 #
1128 # Add package's webserver config to webserver webapps dir.
1129 # Usage:
1130 #   %webapp_register [-f] WEBSERVER WEBAPP
1131 #
1132 %webapp_register(f) \
1133 %{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
1134 if [ -n "%{-f:1}" ] || [ "$1" = "1" ] && [ "$2" = "1" ]; then\
1135         /usr/sbin/webapp register %1 %2\
1136 fi\
1137 # reload webserver if the config symlink is there and skip reload if webserver is upgraded\
1138 if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
1139         %{expand:%service -q %%1 reload}\
1140 fi\
1141 %{nil}
1142
1143 # Remove package's config from webserver webapps dir.
1144 # Usage:
1145 #   %webapp_register [-f] WEBSERVER WEBAPP
1146 %webapp_unregister(f) \
1147 %{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
1148 # remove link if either of the packages are gone \
1149 if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
1150         /usr/sbin/webapp unregister %1 %2\
1151         %{expand:%service -q %%1 reload}\
1152 fi \
1153 %{nil}
1154
1155 # service macro.
1156 # Author: Elan Ruusamäe <glen@pld-linux.org>
1157 #
1158 # calls usual service restart on package %post, but skips the restart if
1159 # administrator has disabled automatic service restarts in either global
1160 # /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
1161 #
1162 # Usage:
1163 #   %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
1164 #
1165 #  -q be silent when service isn't started (for scriplets restaring other package's services)
1166 #  -n NOOP mode, do not actually restart service
1167 #
1168 # Requirements:
1169 # BuildRequires:        rpmbuild(macros) >= 1.268
1170 # Requires:     rc-scripts
1171 # -n option:
1172 # BuildRequires:        rpmbuild(macros) >= 1.450
1173 %service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
1174
1175
1176 # Java macros. based on jpackage macros.java
1177 #
1178 # Root directory where all Java VMs/SDK/JREs are installed.
1179 %_jvmdir                %{_libdir}/jvm
1180
1181 # Root directory where all Java VMs/SDK/JREs expose their jars
1182 %_jvmjardir             %{_libdir}/jvm-exports
1183
1184 # Root directory for all Java VM/SDK/JRE's private things.
1185 %_jvmprivdir    %{_libdir}/jvm-private
1186
1187 # Root directory for all architecture dependent parts of Java VM/SDK/JRE's
1188 %_jvmlibdir             %{_libdir}/jvm
1189
1190 # Root directory for all architecture independent parts of Java VM/SDK/JRE's
1191 %_jvmdatadir    %{_datadir}/jvm
1192
1193 # Root directory for all configurations parts of Java VM/SDK/JRE's
1194 %_jvmsysconfdir %{_sysconfdir}/jvm
1195
1196 # Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
1197 %_jvmcommonlibdir       %{_libdir}/jvm-common
1198
1199 # Root directory for all common architecture independent parts of Java VM/SDK/JRE's
1200 %_jvmcommondatadir      %{_datadir}/jvm-common
1201
1202 # Root directory for all common configurations parts of Java VM/SDK/JRE's
1203 %_jvmcommonsysconfdir   %{_sysconfdir}/jvm-common
1204
1205 # Directory where arch-specific (JNI) version-independent jars are installed.
1206 %_jnidir                %{_libdir}/java
1207
1208 %java_home              %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})}%java_home
1209
1210 %ant                    JAVA_HOME=%{java_home} CLASSPATH=$CLASSPATH ant
1211 %jar                    %{java_home}/bin/jar
1212 %java                   %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)}%java
1213 %javac                  %{java_home}/bin/javac
1214 %javadoc                %{java_home}/bin/javadoc
1215
1216 %add_jvm_extension      JAVA_LIBDIR=%{buildroot}/%{_javadir}    %{_bindir}/jvmjar -l
1217
1218 %jpackage_script() \
1219 install -d $RPM_BUILD_ROOT%{_bindir}\
1220 cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
1221 #!/bin/sh\
1222 #\
1223 # %{name} script\
1224 # JPackage Project <http://www.jpackage.org/>\
1225 \
1226 # Source functions library\
1227 . %{_javadir}-utils/java-functions\
1228 \
1229 # Source system prefs\
1230 if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
1231     . %{_sysconfdir}/java/%{name}.conf\
1232 fi\
1233 \
1234 # Source user prefs\
1235 if [ -f $HOME/.%{name}rc ]; then\
1236     . $HOME/.%{name}rc\
1237 fi\
1238 \
1239 # Configuration\
1240 MAIN_CLASS=%1\
1241 BASE_FLAGS=%2\
1242 BASE_OPTIONS=%3\
1243 BASE_JARS="%(echo %4 | tr ':' ' ')"\
1244 \
1245 # Set parameters\
1246 set_jvm\
1247 set_classpath $BASE_JARS\
1248 set_flags $BASE_FLAGS\
1249 set_options $BASE_OPTIONS\
1250 \
1251 # Let's start\
1252 run "$@"\
1253 EOF
1254
1255 # jpackage 1.7
1256 # Directory for maven depmaps
1257 #
1258 %_mavendepmapdir /etc/maven
1259 %_mavendepmapfragdir /etc/maven/fragments
1260
1261 #
1262 # add_to_depmap adds an entry to the depmap. The arguments are:
1263 #
1264 # %1 the original groupid
1265 # %2 the original artifact id
1266 # %3 the version
1267 # %4 the new groupid
1268 # %5 the new artifactid
1269 #
1270
1271 %add_to_maven_depmap() \
1272 install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1273 cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1274 <dependency>\
1275     <maven>\
1276         <groupId>%1</groupId>\
1277         <artifactId>%2</artifactId>\
1278         <version>%3</version>\
1279     </maven>\
1280     <jpp>\
1281         <groupId>%4</groupId>\
1282         <artifactId>%5</artifactId>\
1283         <version>%3</version>\
1284     </jpp>\
1285 </dependency>\
1286 \
1287 EOF\
1288 %{nil}
1289
1290 #==============================================================================
1291 #
1292 # update_maven_depmap updates the main maven depmap
1293 #
1294 %update_maven_depmap() \
1295 echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1296 if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1297 cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1298 fi\
1299 echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1300
1301 # JAVA macros specific for PLD
1302
1303 # Directory for tomcat context configuration files
1304 %_tomcatconfdir %{_sharedstatedir}/tomcat/conf/Catalina/localhost
1305
1306 # Tomcat cache path
1307 %_tomcatcachedir %{_sharedstatedir}/tomcat/work/Catalina/localhost
1308
1309 # Clear tomcat cache
1310 # Author: Paweł Zuzelski <pawelz@pld-linux.org>
1311 #
1312 # Usage:
1313 # %%tomcat_clear_cache appname
1314 #
1315 # Call this script in %postun scriptlet. It will remove compiled jsps related to
1316 # given app.
1317 #
1318 %tomcat_clear_cache() %{!?1:ERROR}%{?2:ERROR} %{__rm} -rf %{_tomcatcachedir}/%1
1319
1320 # PEAR install macros
1321 # Author: Elan Ruusamäe <glen@pld-linux.org>
1322 #
1323 # Usage:
1324 #       %%pear_package_setup ...
1325 #
1326 # -a #   - also unpack SOURCE#. for PEAR bootstrapping
1327 # -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
1328 # -z     - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
1329 # -D     - pass -D to %setup (so the build dir is not removed)
1330 # -c     - register channel from local channel.xml file
1331 #
1332 # unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1333 # destination hierarchy. you should copy the tree to buildroot after
1334 # patching/reorganizing with %%pear_package_install.
1335 #
1336 # additionally BUILDROOT is stripped from files and files are converted to UNIX
1337 # line endings.
1338 #
1339 # the pear install process output is recorded to install.log, you should put it
1340 # to %%doc for later debug or just for information.
1341 #
1342 # additionally additional-packages.txt is produced if it was detected that the
1343 # package has optional dependencies. the file format is suitable of displaying
1344 # in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1345 # automatically added for this file.
1346
1347
1348 # records install.log and transforms PEAR names to PLD Linux rpm package names.
1349 %__pear_install_log \
1350 tee install.log \
1351 # make post message of optional packages \
1352 grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,;s,^pear/,php-pear-,;s,^channel://.*/,,' > optional-packages.txt \
1353 if [ -s optional-packages.txt ]; then \
1354         awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1355 else \
1356         rm -f optional-packages.txt \
1357 fi \
1358 %{nil}
1359
1360 # command invoking pear cli
1361 %__pear /usr/bin/pear
1362
1363 %pear_install(a:n:zD) \
1364 %__pear \\\
1365         -c %{builddir}/pearrc \\\
1366         -d doc_dir=/docs \\\
1367         -d temp_dir=/tmp \\\
1368         -d php_dir=%{-c:%{builddir}/}%{php_pear_dir} \\\
1369         -d bin_dir=%{_bindir} \\\
1370         -d data_dir=%{php_pear_dir}/data \\\
1371         -d test_dir=%{php_pear_dir}/tests \\\
1372         install \\\
1373         --packagingroot=%{builddir} \\\
1374         --offline \\\
1375         --nodeps \\\
1376         %{-f:--force} \\\
1377         %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
1378         %{-c:cp -a %{builddir}/%{builddir}/%{php_pear_dir} %{builddir}/%(dirname %{php_pear_dir}); rm -rf %{builddir}/%{builddir}; } \
1379 %{nil}
1380
1381 # The main macro.
1382 # using this macro will append optional-packages.txt to the nocompressdoc list
1383 # as it's displayed to user after package install. and adding additional gzip
1384 # dep is just waste ;)
1385 %pear_package_setup(a:n:zDc:) \
1386 %define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1387 %define builddir %{_builddir}/%{srcdir} \
1388 %setup -q -c -T %{-D:-D} -n %{srcdir} \
1389 %{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1390 %{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1391 %{-c:%{__pear} -c pearrc config-set php_dir %{builddir}/%{php_pear_dir}; %__pear -c %{builddir}/pearrc channel-add %{-c*}} \
1392 %pear_install \
1393 %{-z:cd ..} \
1394 cat %{-z:$_N/}.install.log | %__pear_install_log \
1395 \
1396 # undos sources \
1397 find -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
1398 %{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1399 %{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1400 %{nil}
1401
1402 # Copies exctracted PEAR package structure and PEAR registry to buildroot.
1403 # Author: Elan Ruusamäe <glen@pld-linux.org>
1404 %pear_package_install() \
1405 cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1406 find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1407 # help the developer out a little: \
1408 if [ -f _noautoreq ]; then \
1409         echo "AutoReqdep detected:" \
1410         echo "_noautoreq $(cat _noautoreq)" \
1411 fi \
1412 %{nil}
1413
1414
1415 # Register OpenLDAP schema.
1416 # Author: Elan Ruusamäe <glen@pld-linux.org>
1417 #
1418 # Usage:
1419 #   %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1420 #
1421 #  -d specify dependant schemas, separated by comma
1422 #
1423 %openldap_schema_register(d:) \
1424 for schema in %*; do \
1425         if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1426                 %{__sed} -i -e " \
1427                         /^include.*local.schema/{ \
1428                                 iinclude\\t     $schema\
1429                         } \
1430                 " /etc/openldap/slapd.conf \
1431         fi \
1432 done \
1433 # enable dependant schemas \
1434 if [ "%{-d*}" ]; then \
1435         %{__sed} -i -e ' \
1436         /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1437                 s/^#// \
1438         }' /etc/openldap/slapd.conf \
1439 fi \
1440 %{nil}
1441
1442 # Unregister OpenLDAP schema.
1443 # Author: Elan Ruusamäe <glen@pld-linux.org>
1444 #
1445 # Usage:
1446 #   %%openldap_schema_unregister %{schemadir}/horde.schema
1447 #
1448 %openldap_schema_unregister() \
1449 for schema in %*; do \
1450         if grep -q "$schema" /etc/openldap/slapd.conf; then \
1451                 %{__sed} -i -e " \
1452                 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1453                 # for symmetry it would be nice if we disable enabled schemas in post, \
1454                 # but we really can not do that, it would break something else. \
1455                 " /etc/openldap/slapd.conf \
1456         fi \
1457 done \
1458 %{nil}
1459
1460 %env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1461
1462
1463 # Build modules for kernels 2.6
1464 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1465 #
1466 # Usage:
1467 #       %build_kernel_modules -m <modules> -C <directory>
1468 #
1469 #  remember that proper Makefile is still required
1470 # Options:
1471 #  -m <modules> (required) -- comma-separated list of modules to save,
1472 #               without .ko extension, may be placed in subdirectory
1473 #  -C <directory> -- change to <directory> before doing anything
1474 #  -p <arg>, -P <arg> -- arguments passeed to make scripts
1475 #  -c -- do not execute make clean
1476 #  <additional arguments> -- all additional arguments will be passed to
1477 #               make modules
1478 #
1479 # Additional patching supported via here document. Try:
1480 #       %build_kernel_modules -m module <<'EOF'
1481 #       your patch script here
1482 #       EOF
1483 # Don't use it unless patching depends on config options.
1484
1485 # Developer note: don't touch it unless you know how to handle '\'.
1486 # - \ in script expands to nothing
1487 # - \\\ in script expands to \
1488 # - \\\ inside definition expands to nothing
1489 # - \\\\\\\ inside definition expands to \
1490 # - in last line \ has to touch arguments so arguments passing
1491 #   in new lines (using \) will be supported
1492
1493 %build_kernel_modules(p:P:m:C:c)                                                                        \
1494 %{!?-m:%{error:%{0}: Required module name/list missing} exit 1}         \
1495                                                                                                                                         \
1496 %define Opts                                                                                                            \\\\\\\
1497 %if "%{_target_base_arch}" != "%{_arch}"                                                        \\\
1498         %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386"  \\\
1499         CC="%{kgcc}" ARCH=%{_target_base_arch}                                                  \\\
1500         %else                                                                                                                   \\\
1501         ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1502         %endif                                                                                                                  \\\
1503 %else                                                                                                                           \\\
1504         CC="%{kgcc}"                                                                                                    \\\
1505 %endif                                                                                                                          \
1506 %define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
1507                 O=$PWD/o %{?with_verbose:V=1} %{Opts}                                           \
1508                                                                                                                                         \
1509 %{?-C:cd %{-C*}}                                                                                                        \
1510 compile() {                                                                                                                     \
1511         local L="<" PATCH_SH;                                                                                   \
1512         [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)"                   \
1513         set -e -x                                                                                                               \
1514         local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1515                                                                                                                                         \
1516 for cfg in ${cfgs:-dist}; do                                        \
1517         [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1                                 \
1518                                                                                                                                         \
1519         rm -rf o                                                                                                                \
1520         install -d o/include/linux o/include/generated o/arch/powerpc/lib       \
1521         ln -sf %{_kernelsrcdir}/config-$cfg o/.config                                   \
1522         ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers    \
1523         if [ -f %{_kernelsrcdir}/include/generated/autoconf-$cfg.h ]; then      \
1524                 ln -sf %{_kernelsrcdir}/include/generated/autoconf-$cfg.h o/include/generated/autoconf.h \
1525                 ln -s ../generated/autoconf.h o/include/linux/autoconf.h \
1526         else                                                                                                                    \
1527                 ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1528         fi                                                                                                                              \
1529                                                                                                                                         \
1530         set +x                                                                                                                  \
1531         [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell    \
1532         set -x                                                                                                                  \
1533                                                                                                                                         \
1534         %if %{with dist_kernel} || %(test -f %{_kernelsrcdir}/scripts/bin2c ; echo $?)  \
1535                 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts                       \\\
1536                         %{-p*} %{-P*}                                                                                   \\\
1537                         %{MakeOpts}                                                                                             \
1538         %else                                                                                                                   \
1539                 install -d o/include/config                                                                     \
1540                 touch o/include/config/MARKER                                                           \
1541                 ln -sf %{_kernelsrcdir}/include/config/auto-$cfg.conf o/include/config/auto.conf        \
1542                 ln -sf %{_kernelsrcdir}/scripts o/scripts                                       \
1543         %endif                                                                                                                  \
1544                                                                                                                                         \
1545         %{!?-c:%{__make} -C %{_kernelsrcdir} clean                                              \\\
1546                 RCS_FIND_IGNORE="-name '*.ko' -o"                                                       \\\
1547                 ${1+"$@"}                                                                                                       \\\
1548                 M=$PWD %{MakeOpts}}                                                                                     \
1549                                                                                                                                         \
1550         %{__make} -C %{_kernelsrcdir} modules                                                   \\\
1551                 ${1+"$@"}                                                                                                       \\\
1552                 M=$PWD %{MakeOpts}                                                                                      \
1553                                                                                                                                         \
1554         for MODULE in {%{-m*},}; do                                                                             \
1555                 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko                           \
1556         done                                                                                                                    \
1557 done                                                                                                                            \
1558 %{?-C:cd -}                                                                                                                     \
1559 }                                                                                                                                       \
1560 compile %{*}\
1561 %{nil}
1562
1563
1564 # Install kernel modules built by %build_kernel_modules
1565 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1566 #
1567 # Usage:
1568 #       %install_kernel_modules -m <modules> -d <directory>
1569 #
1570 # Options:
1571 #  -m <modules> (required) -- comma-separated list of modules to install,
1572 #               without .ko extension, may be placed in subdirectory
1573 #  -d <directory> (required) -- in what subdirectory modules should be
1574 #               installed (eg. misc, kernel/drivers/net)
1575 #  -s <suffix> -- suffix to use when installing modules, useful when module
1576 #               with same name exists in kernel already
1577 #  -n <file> -- name of modprobe config file to use (without .conf extension)
1578 #               for defining aliases, only useful with -s
1579
1580 %install_kernel_modules(m:d:s:n:)                                                                       \
1581 %{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1}          \
1582 %{!?-d:%{error:%{0}: Required module directory missing}exit 1}          \
1583 %{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1584                                                                                                                                         \
1585 %define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}                      \
1586 %define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
1587                                                                                                                                         \
1588 __install_kernel_modules() {                                                                            \
1589 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1590                                                                                                                                         \
1591 for MODULE in {%{-m*},}; do                                                                                     \
1592         [ -n "${MODULE}" ] || continue                                                                  \
1593         for cfg in ${cfgs:-dist}; do                                    \
1594                 [ "$cfg" = smp ] && suf=smp || suf=                                                     \
1595                 MNAME=${MODULE##*/}                                                                                     \
1596                 install -D ${MODULE}-$cfg.ko                                                            \\\
1597                         %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                  \
1598                 %{?-s:install -d %{ModprobeD}$suf                                                       \
1599                         echo "alias ${MNAME} ${MNAME}-%{-s*}"                                   \\\
1600                         >> %{ModprobeD}$suf/%{-n*}.conf}                                                \
1601         done                                                                                                                    \
1602 done                                                                                                                            \
1603 }                                                                                                                                       \
1604 __install_kernel_modules                                                                                        \
1605 %{nil}
1606
1607 # patchset macros
1608 # Author: Elan Ruusamäe <glen@pld-linux.org>
1609 #
1610 # Usage:
1611 #   %patchset_source -f <seq(1) format> <start> [<end>]
1612 #   %patchset_patch <start> [<end>]
1613 #
1614 # If <end> is omited, it is assumed to be <start>.
1615 #
1616 # For example in preamble:
1617 #  %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1618 # and in %prep:
1619 #  %patchset_patch 33 44
1620
1621 # generate SourceX urls from range START STOP
1622 # Format can be SINGLE format char of %e, %f, %g, see seq(1)
1623 # The sources start from 10000
1624 %patchset_source(f:b:) %(
1625         base=%{-b*}%{!-b*:10000};
1626         start=$(expr $base + %1);
1627         end=$(expr $base + %{?2}%{!?2:%{1}});
1628         # we need to call seq twice as it doesn't allow two formats
1629         seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1630         seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1631         paste %{tmpdir}/__ps{1,2};
1632         rm -f %{tmpdir}/__ps{1,2};
1633 ) \
1634 %{nil}
1635
1636 # apply sources from %patchset_source
1637 # -p specify -pX for %patch line
1638 # -b base offset: defaults to 10000
1639 %patchset_patch(f:p:b:) %(
1640         base=%{-b*}%{!-b*:10000};
1641         start=$(expr $base + %1);
1642         end=$(expr $base + %{?2}%{!?2:%{1}});
1643         echo ": patchset_patch %1%{?2: to %2}";
1644         seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
1645 ) \
1646 %{nil}
1647
1648 # browser plugins v2
1649 # Author: Elan Ruusamäe <glen@pld-linux.org>
1650 #
1651 # Usage:
1652 #       %browser_plugins_add_browser <name> -p <plugindir>
1653 #
1654 #  <name> (required) -- name of the browser. usually %{name}.
1655 #  -p <plugindir> (required) -- in what directory browser searches for its plugins.
1656 #  -b -- default blacklists
1657 #  -a <arch> override arch
1658 #
1659 # Example:
1660 #   %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1661
1662 %_browserpluginsconfdir         /etc/browser-plugins
1663 %_browserpluginsdir                     %{_libdir}/browser-plugins
1664 %update_browser_plugins         /usr/sbin/update-browser-plugins || :
1665
1666 %browser_plugins_add_browser(p:b:a:) \
1667         browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
1668         install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
1669         ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1670         blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
1671         echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1672         %{-b:cat >> $blacklist_file %{-b*}} \
1673 %{nil}
1674
1675 # Helper for LUA.
1676 # split string separated by space into quoted list
1677 #
1678 # Author: Elan Ruusamäe <glen@pld-linux.org>
1679 #
1680 # %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1681 %__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1682
1683 # adjust /etc/shells by adding and removing shells from there
1684 # Author: Elan Ruusamäe <glen@pld-linux.org>
1685 #
1686 # Usage:
1687 #   %post       -p <lua>
1688 #   %lua_add_etc_shells /bin/sh /bin/pdksh
1689 #
1690 #   %preun      -p <lua>
1691 #   if arg[2] == 0 then
1692 #       %lua_remove_etc_shells /bin/bash /bin/rbash
1693 #   end
1694 #
1695 # Requirements:
1696 # BuildRequires:        rpmbuild(macros) >= 1.462
1697 #
1698
1699 %lua_add_etc_shells() \
1700 t = {}\
1701 f = io.open("/etc/shells", "r")\
1702 if f then\
1703         for l in f:lines() do t[l]=l; end\
1704         f:close()\
1705 end\
1706 for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1707         if not t[s] then\
1708                 print("Adding "..s.." to /etc/shells")\
1709                 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1710         end\
1711 end\
1712 %{nil}
1713
1714 %lua_remove_etc_shells() \
1715 t = {}\
1716 f = io.open("/etc/shells", "r")\
1717 if f then\
1718         for l in f:lines() do t[l]=l; end\
1719         f:close()\
1720 end\
1721 for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1722         print("Removing "..l.." from /etc/shells")\
1723         t[l] = nil\
1724 end\
1725 s=""\
1726 for _, l in pairs(t) do\
1727         s=s..l.."\\n"\
1728 end\
1729 io.open("/etc/shells", "w"):write(s)\
1730 %{nil}
1731
1732 # Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
1733 #
1734 # Author: Elan Ruusamäe <glen@pld-linux.org>
1735 #
1736 # Usage:
1737 #   %post       -p %add_etc_shells -p /bin/sh /bin/pdksh
1738 #   %preun      -p %remove_etc_shells -p /bin/sh /bin/pdksh
1739 #
1740 #  -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1741 #
1742 # Requirements:
1743 # BuildRequires:        rpmbuild(macros) >= 1.429
1744 #
1745 %add_etc_shells(p) %{-p:<lua>}\
1746 %{expand:%%lua_add_etc_shells %*}\
1747 %{nil}
1748
1749 %remove_etc_shells(p) %{-p:<lua>}\
1750 %{-p:if arg[2] == 0 then}\
1751 %{expand:%%lua_remove_etc_shells %*}\
1752 %{-p:end} \
1753 %{nil}
1754
1755 # Check syntax for Python files
1756 #
1757 # Author: Elan Ruusamäe <glen@pld-linux.org>
1758 # Author: Arkadiusz Miśkiewicz <arekm@pld-linux.org>
1759 #
1760 # Usage:
1761 #   %py_lint src
1762 #
1763 # Requirements:
1764 # BuildRequires:        python
1765 # BuildRequires:        rpmbuild(macros) >= 1.469
1766
1767 %py_lint() \
1768 __py_lint() { \
1769 find "$@" -type f -name '*.py' | python -c ' \
1770 import sys \
1771 import compiler \
1772 \
1773 err = 0\
1774 for f in sys.stdin: \
1775         fd = open(f.strip()) \
1776         c = fd.read() \
1777         fd.close() \
1778         try: \
1779                 compiler.parse(c) \
1780         except SyntaxError, e: \
1781                 print "py_lint: %s: %s" % (f.strip(), e) \
1782                 err = err + 1\
1783 \
1784 if err: \
1785         print >> sys.stderr, "\\npy_lint: ERROR: Syntax errors in %d files.\\n" % err \
1786         sys.exit(1) \
1787 else: \
1788         print >> sys.stderr,  "py_lint: Found no syntax errors." \
1789 ' \
1790 }; __py_lint %* \
1791 %{nil}
1792
1793 # Undos files
1794 #
1795 # Author: Paweł Zuzelski <pawelz@pld-linux.org>
1796 #
1797 # Usage:
1798 #   %undos list_of_files
1799 #
1800 # Requirements:
1801 # BuildRequires:        sed >= 4.0
1802 # BuildRequires:        rpmbuild(macros) >= 1.533
1803
1804 %undos \
1805 %{__sed} -i -e 's,\\r$,,'
1806
1807 # Hook to register nagios object based plugins in Nagios NRPE daemon config.
1808 #
1809 # Author: Elan Ruusamäe <glen@pld-linux.org>
1810 #
1811 # Usage:
1812 #  -a NAME  -- add command named NAME
1813 #  -d NAME  -- remove command named NAME
1814 #  -f FILE  -- specify plugin configuration FILE to extract command definition from
1815 #
1816 # Sample:
1817 # %triggerin -- nagios-nrpe
1818 # %nagios_nrpe -a %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
1819 #
1820 # %triggerun -- nagios-nrpe
1821 # %nagios_nrpe -d %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
1822 #
1823 # Requirements:
1824 # BuildRequires:        sed >= 4.0
1825 # BuildRequires:        rpmbuild(macros) >= 1.551
1826 %nagios_nrpe(a:d:c:f:) {\
1827         %{-a:# on -a and config exists \
1828         if [ "%{-a*}" -a -f /etc/nagios/nrpe.cfg ]; then \
1829                 if ! grep -q '^command\[%{-a*}\]' /etc/nagios/nrpe.cfg; then \
1830                                 sed -ne 's/^[ \t]*command_line[ \t]\+\(.\+\)/command[%{-a*}]=\1/p' %{-f*} >> /etc/nagios/nrpe.cfg; \
1831                 fi; \
1832         fi;} \
1833         %{-d:# on package remove, -d and config exists \
1834         if [ "$1" = "0" -a "%{-d*}" -a -f /etc/nagios/nrpe.cfg ]; then \
1835                 sed -i -e '/^[ \t]*command\[%{-d*}\]/d' /etc/nagios/nrpe.cfg; \
1836         fi;} \
1837 }%{nil}
1838
1839
1840 # vim:ts=4 sw=4 noet ft=spec
This page took 0.443024 seconds and 3 git commands to generate.